## perceptualdiff 1.0.1

=== CMakeLists.txt ===
PROJECT (PerceptualDiff)
SET(DIFF_SRC PerceptualDiff.cpp LPyramid.cpp RGBAImage.cpp
CompareArgs.cpp Metric.cpp)

ADD_EXECUTABLE (perceptualdiff ${DIFF_SRC})

INSTALL(FILES perceptualdiff DESTINATION bin)

# look for libtiff
FIND_PATH(TIFF_INCLUDE_DIR tiff.h
  /usr/local/include
  /usr/include
  /opt/local/include
)

FIND_LIBRARY(TIFF_LIBRARY tiff
  /usr/lib
  /usr/local/lib
  /opt/local/lib
)

IF(TIFF_INCLUDE_DIR)
  IF(TIFF_LIBRARY)
    SET( TIFF_FOUND "YES" )
    SET( TIFF_LIBRARIES ${TIFF_LIBRARY} )
  ENDIF(TIFF_LIBRARY)
ENDIF(TIFF_INCLUDE_DIR)

IF(TIFF_FOUND)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
  TARGET_LINK_LIBRARIES(perceptualdiff ${TIFF_LIBRARY})
ENDIF(TIFF_FOUND)

# look for libpng
FIND_PATH(PNG_INCLUDE_DIR png.h
  /usr/local/include
  /usr/include
  /opt/local/include
)

FIND_LIBRARY(PNG_LIBRARY png
  /usr/lib
  /usr/local/lib
  /opt/local/lib
)

IF(PNG_INCLUDE_DIR)
  IF(PNG_LIBRARY)
    SET( PNG_FOUND "YES" )
    SET( PNG_LIBRARIES ${PNG_LIBRARY} )
  ENDIF(PNG_LIBRARY)
ENDIF(PNG_INCLUDE_DIR)

IF(PNG_FOUND)
  INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
  TARGET_LINK_LIBRARIES(perceptualdiff ${PNG_LIBRARY})
ENDIF(PNG_FOUND)

#
# Packing stuff
#
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")
set(CPACK_PACKAGE_VERSION_PATCH "1")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An image comparison utility.")
set(CPACK_PACKAGE_VENDOR "pdiff dev team")
set(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/README.txt)
set(CPACK_GENERATOR TGZ)
set(
CPACK_SOURCE_PACKAGE_FILE_NAME
"PerceptualDiff-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}"
CACHE INTERNAL "tarball basename"
)
set(CPACK_SOURCE_GENERATOR TGZ)
# The following components are regex's to match anywhere (unless anchored)
# in absolute path + filename to find files or directories to be excluded
# from source tarball.
set(CPACK_SOURCE_IGNORE_FILES
"~$"
"\\\\.cvsignore$"
"^${PROJECT_SOURCE_DIR}/CMakeFiles/"
"^${PROJECT_SOURCE_DIR}/CMakeCache.txt"
"^${PROJECT_SOURCE_DIR}/CPackSourceConfig.cmake"
"^${PROJECT_SOURCE_DIR}/CPackConfig.cmake"
"^${PROJECT_SOURCE_DIR}/Makefile"
"^${PROJECT_SOURCE_DIR}/_CPack_Packages"
"^${PROJECT_SOURCE_DIR}/test/"
"^${PROJECT_SOURCE_DIR}/cmake_install.cmake"
)
include(CPack)

## perceptualdiff 1.1.1

=== CMakeLists.txt ===
PROJECT (PerceptualDiff)

CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

SET(DIFF_SRC PerceptualDiff.cpp LPyramid.cpp RGBAImage.cpp
CompareArgs.cpp Metric.cpp)

ADD_EXECUTABLE (perceptualdiff ${DIFF_SRC})

INSTALL(TARGETS perceptualdiff DESTINATION bin)

# look for freeimage
FIND_PATH(FREEIMAGE_INCLUDE_DIR FreeImage.h
  /usr/local/include
  /usr/include
  /opt/local/include
)
FIND_LIBRARY(FREEIMAGE_LIBRARY freeimage
  /usr/lib
  /usr/local/lib
  /opt/local/lib
)

IF(FREEIMAGE_INCLUDE_DIR)
  IF(FREEIMAGE_LIBRARY)
    SET( FREEIMAGE_FOUND "YES" )
    SET( FREEIMAGE_LIBRARIES ${FREEIMAGE_LIBRARY} )
  ENDIF(FREEIMAGE_LIBRARY)
ENDIF(FREEIMAGE_INCLUDE_DIR)

IF(FREEIMAGE_FOUND)
  INCLUDE_DIRECTORIES(${FREEIMAGE_INCLUDE_DIR})
  TARGET_LINK_LIBRARIES(perceptualdiff ${FREEIMAGE_LIBRARY})
ENDIF(FREEIMAGE_FOUND)

#
# Packing stuff
#
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "1")
set(CPACK_PACKAGE_VERSION_PATCH "1")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An image comparison utility.")
set(CPACK_PACKAGE_VENDOR "pdiff dev team")
set(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/README.txt)
set(CPACK_GENERATOR TGZ)
set(
CPACK_SOURCE_PACKAGE_FILE_NAME
"PerceptualDiff-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}"
CACHE INTERNAL "tarball basename"
)
set(CPACK_SOURCE_GENERATOR TGZ)
# The following components are regex's to match anywhere (unless anchored)
# in absolute path + filename to find files or directories to be excluded
# from source tarball.
set(CPACK_SOURCE_IGNORE_FILES
"~$"
"\\\\.cvsignore$"
"^${PROJECT_SOURCE_DIR}/CMakeFiles/"
"^${PROJECT_SOURCE_DIR}/CMakeCache.txt"
"^${PROJECT_SOURCE_DIR}/CPackSourceConfig.cmake"
"^${PROJECT_SOURCE_DIR}/CPackConfig.cmake"
"^${PROJECT_SOURCE_DIR}/Makefile"
"^${PROJECT_SOURCE_DIR}/_CPack_Packages"
"^${PROJECT_SOURCE_DIR}/test/"
"^${PROJECT_SOURCE_DIR}/cmake_install.cmake"
)
include(CPack)

## perceptualdiff 1.2

=== CMakeLists.txt ===
project(PerceptualDiff)

cmake_minimum_required(VERSION 2.4)

add_executable(
  perceptualdiff
  PerceptualDiff.cpp LPyramid.cpp RGBAImage.cpp CompareArgs.cpp Metric.cpp)

install(TARGETS perceptualdiff DESTINATION bin)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})

set(FREEIMAGE_FIND_REQUIRED, TRUE)
find_package(FreeImage)
include_directories(${FREEIMAGE_INCLUDE_DIRS})
target_link_libraries(perceptualdiff ${FREEIMAGE_LIBRARIES})

set(CMAKE_BUILD_TYPE Debug)

find_package(OpenMP)
if(OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()

option(OPTIMIZATION "Enable optimization" TRUE)
if(OPTIMIZATION)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -Wall -Wextra -pedantic -Wcast-qual -Wpointer-arith -Winit-self -Wswitch-default -Wmissing-include-dirs -Wold-style-cast -Wnon-virtual-dtor -Wshadow -Wno-unknown-pragmas")

# Packing stuff.
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "1")
set(CPACK_PACKAGE_VERSION_PATCH "2")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An image comparison utility.")
set(CPACK_PACKAGE_VENDOR "pdiff dev team")
set(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/README.rst)
set(CPACK_GENERATOR TGZ)
set(
  CPACK_SOURCE_PACKAGE_FILE_NAME
  "PerceptualDiff-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}"
  CACHE INTERNAL "tarball basename"
)
set(CPACK_SOURCE_GENERATOR TGZ)
# The following components are regex's to match anywhere (unless anchored)
# in absolute path + filename to find files or directories to be excluded
# from source tarball.
set(CPACK_SOURCE_IGNORE_FILES
"~$"
"/\\\\.gitignore$"
"/\\\\..*\\\\.swp$"
"^${PROJECT_SOURCE_DIR}/\\\\.git/"
"^${PROJECT_SOURCE_DIR}/CMakeFiles/"
"^${PROJECT_SOURCE_DIR}/CMakeCache.txt"
"^${PROJECT_SOURCE_DIR}/CPackSourceConfig.cmake"
"^${PROJECT_SOURCE_DIR}/CPackConfig.cmake"
"^${PROJECT_SOURCE_DIR}/CTestTestfile.cmake"
"^${PROJECT_SOURCE_DIR}/Makefile"
"^${PROJECT_SOURCE_DIR}/_CPack_Packages"
"^${PROJECT_SOURCE_DIR}/cppcheck.bash"
"^${PROJECT_SOURCE_DIR}/cmake_install.cmake"
"^${PROJECT_SOURCE_DIR}/install_manifest.txt"
"^${PROJECT_SOURCE_DIR}/perceptualdiff"
"^${PROJECT_SOURCE_DIR}/PerceptualDiff-.*"
"^${PROJECT_SOURCE_DIR}/Testing"
"^${PROJECT_SOURCE_DIR}/lcov.info"
"^${PROJECT_SOURCE_DIR}/lcov_tmp.info"
"^${PROJECT_SOURCE_DIR}/coverage_output"
)
include(CPack)

# Tests.
enable_testing()
add_test(run_tests.bash, "${PROJECT_SOURCE_DIR}/test/run_tests.bash")
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
                  DEPENDS "perceptualdiff")

## perceptualdiff 2.1

=== CMakeLists.txt ===
project(perceptualdiff)

cmake_minimum_required(VERSION 2.4)

add_library(
    pdiff
    lpyramid.cpp rgba_image.cpp metric.cpp)

add_executable(
    perceptualdiff
    compare_args.cpp perceptualdiff.cpp)
target_link_libraries(perceptualdiff pdiff)

install(TARGETS perceptualdiff DESTINATION bin)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})

set(FREEIMAGE_FIND_REQUIRED, TRUE)
find_package(FreeImage)
include_directories(SYSTEM ${FREEIMAGE_INCLUDE_DIRS})
target_link_libraries(perceptualdiff ${FREEIMAGE_LIBRARIES})

set(CMAKE_BUILD_TYPE Debug)

find_package(OpenMP)
if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()

option(OPTIMIZATION "Enable optimization" TRUE)
if(OPTIMIZATION)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
endif()

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -Wall -Wextra -pedantic -Wcast-qual -Wpointer-arith -Winit-self -Wswitch-default -Wmissing-include-dirs -Wold-style-cast -Wnon-virtual-dtor -Wshadow -Wno-unknown-pragmas")
endif(MSVC)

# Packing stuff.
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "2")
set(CPACK_PACKAGE_VERSION_PATCH "0")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An image comparison utility.")
set(CPACK_PACKAGE_VENDOR "pdiff dev team")
set(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/README.rst)
set(CPACK_GENERATOR TGZ)
set(CPACK_SOURCE_PACKAGE_FILE_NAME
    "perceptualdiff-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}"
    CACHE INTERNAL "tarball basename"
)
set(CPACK_SOURCE_GENERATOR TGZ)
# The following components are regex's to match anywhere (unless anchored)
# in absolute path + filename to find files or directories to be excluded
# from source tarball.
set(CPACK_SOURCE_IGNORE_FILES
    "~$"
    "/\\\\.gitignore$"
    "/\\\\..*\\\\.swp$"
    "^${PROJECT_SOURCE_DIR}/\\\\.git/"
    "^${PROJECT_SOURCE_DIR}/CMakeFiles/"
    "^${PROJECT_SOURCE_DIR}/CMakeCache.txt"
    "^${PROJECT_SOURCE_DIR}/CPackSourceConfig.cmake"
    "^${PROJECT_SOURCE_DIR}/CPackConfig.cmake"
    "^${PROJECT_SOURCE_DIR}/CTestTestfile.cmake"
    "^${PROJECT_SOURCE_DIR}/Makefile"
    "^${PROJECT_SOURCE_DIR}/_CPack_Packages"
    "^${PROJECT_SOURCE_DIR}/cmake_install.cmake"
    "^${PROJECT_SOURCE_DIR}/install_manifest.txt"
    "^${PROJECT_SOURCE_DIR}/perceptualdiff"
    "^${PROJECT_SOURCE_DIR}/perceptualdiff-.*"
    "^${PROJECT_SOURCE_DIR}/Testing"
    "^${PROJECT_SOURCE_DIR}/coverage_output"
)
include(CPack)

# Tests.
enable_testing()
add_test(run_tests.bash, "${PROJECT_SOURCE_DIR}/test/run_tests.bash")
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
                  DEPENDS "perceptualdiff")

=== debian/changelog ===
perceptualdiff (2.1-7.1) unstable; urgency=medium

  * Non-maintainer upload
  * d/copyright: Correct BSD license

 -- Bastian Germann <bage@debian.org>  Mon, 01 Sep 2025 16:27:45 +0200

perceptualdiff (2.1-7) unstable; urgency=medium

  * Guard another test that fails due to a bad library on a couple
    architectures. Figure it out later.  Alignment issues?

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 27 Mar 2023 14:32:03 +0100

perceptualdiff (2.1-6) unstable; urgency=medium

  * Wrap long lines in changelog entries: 2.1-5.1.
  * Update standards version to 4.6.2, no changes needed.

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 26 Mar 2023 22:00:58 -0000

perceptualdiff (2.1-5.1) unstable; urgency=medium

  * Non-maintainer upload
  * Don't test failure when loading a corrupted png file (Closes: #982864,
    #992905)

 -- Dima Kogan <dima@secretsauce.net>  Sun, 19 Feb 2023 19:59:04 -0800

perceptualdiff (2.1-5) unstable; urgency=medium

  [ Barak A. Pearlmutter ]
  * Modernise debian/copyright
  * Update standards version to 4.6.0, no changes needed.

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Remove constraints unnecessary since stretch:
    + Build-Depends: Drop versioned constraint on cmake.

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 11 Oct 2021 17:16:00 +0100

perceptualdiff (2.1-4) unstable; urgency=medium

  * Support autopkgtest
  * Improve perceptualdiff(1) whatis entry

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 18 Apr 2021 14:18:10 +0100

perceptualdiff (2.1-3) unstable; urgency=medium

  * Run test suite manually, since the callout was removed from cmake
  * Quilt patch with --help edits
  * Rebuild debian/perceptualdiff.1 with help2man and patched --help
  * Inactive stanza in debian/rules to rebuild perceptualdiff(1).

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 14 Jan 2021 08:43:38 +0000

perceptualdiff (2.1-2) unstable; urgency=medium

  * Track upstream development
  * Force dh buildsystem to cmake
  * Repair broken old debian/changelog stanza author entry

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 12 Jan 2021 19:43:17 +0000

perceptualdiff (2.1-1) unstable; urgency=medium

  * Update packaging scripts
  * Trivial debian/rules makes logs verbose (closes: #928266)
  * Trim trailing whitespace.
  * Explicitly specify source format.
  * Bump debhelper to 13. (closes: #965773)
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add debian/changelog close clause colons
  * Add debian/watch uscan support file
  * Bump policy
  * New upstream release
    - checks --output error, see 9dffbb97 "Failed to save" (closes: #836777)

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 11 Jan 2021 22:47:03 +0000

perceptualdiff (1.2-2) unstable; urgency=medium

  * Fix build problem
  * Remove unnecessary file (closes: #666886)

 -- Jeff Breidenbach <jab@debian.org>  Tue, 04 Aug 2015 22:23:16 +0000

perceptualdiff (1.2-1) unstable; urgency=medium

  * Switch to OpenMP fork (closes: #673934)

 -- Jeff Breidenbach <jab@debian.org>  Fri, 31 Jul 2015 00:19:43 +0000

perceptualdiff (1.1.1-2) unstable; urgency=low

  * libtiff transition (closes: #736036)
  * libpng transition (closes: #636969, #636969)

 -- Jeff Breidenbach <jab@debian.org>  Tue, 21 Jan 2014 09:00:14 -0800

perceptualdiff (1.1.1-1) unstable; urgency=low

  * New upstream release.
  * Manpage correction. (closes: #564031)

 -- Jeff Breidenbach <jab@debian.org>  Thu, 08 Dec 2011 16:49:55 -0800

perceptualdiff (1.0.1-1.4) unstable; urgency=low

  * Non-maintainer upload.
  * libpng 1.5 transition. (closes: #636969)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sun, 07 Aug 2011 15:23:04 +0900

perceptualdiff (1.0.1-1.3) unstable; urgency=low

  * Non-maintainer upload.
  * Fix build with gcc-4.4 using patch from Martin Michlmayr (Closes:
    #505022)

 -- Christoph Egger <christoph@debian.org>  Fri, 25 Dec 2009 23:27:06 +0100

perceptualdiff (1.0.1-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix gcc-4.3 FTBFS, patch by KiBi (Closes: #456049)

 -- Marc 'HE' Brockschmidt <he@debian.org>  Sun, 16 Mar 2008 21:28:43 +0100

perceptualdiff (1.0.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Remove all cmake-generated files in make clean, avoiding FTBFS
    and reducing Debian diff size (Closes: #445614).

 -- Simon McVittie <smcv@ianadd.pseudorandom.co.uk>  Sun, 14 Oct 2007 12:24:05 +0100

perceptualdiff (1.0.1-1) unstable; urgency=low

  * Initial release

 -- Jeff Breidenbach <jab@debian.org>  Fri, 28 Sep 2007 14:52:18 -0700

=== debian/control ===
Source: perceptualdiff
Section: utils
Priority: optional
Maintainer: Jeff Breidenbach <jab@debian.org>
Uploaders: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13),
	cmake,
	libpng-dev, libtiff-dev, libfreeimage-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/myint/perceptualdiff
Vcs-Git: https://salsa.debian.org/debian/perceptualdiff.git
Vcs-Browser: https://salsa.debian.org/debian/perceptualdiff

Package: perceptualdiff
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: perceptual image comparison tool
 PerceptualDiff is an image comparison utility that makes
 use of a computational model of the human visual system to
 compare two images.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_test:
	if type /bin/bash > /dev/null ; then		\
	  ./test/run_tests.bash;			\
	else						\
	  echo "test script needs bash; skipped.";	\
	fi

.PHONY: rebuild-manpage
rebuild-manpage:
	help2man --name='perceptual image comparison tool' \
	 --no-info					\
	 --output=debian/perceptualdiff.1		\
	 obj-*/perceptualdiff

=== debian/tests/control ===
Test-Command: env tmpdir=${AUTOPKGTEST_TMP} pdiff=/usr/bin/perceptualdiff script_directory=${PWD}/test ./test/run_tests.bash
Depends: @, grep
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://github.com/myint/@PACKAGE@/tags \
 .*/v?@ANY_VERSION@@ARCHIVE_EXT@
